function legend (args)

* args = label# nvars xloc label1 label2 label3 label4 label5 label6 .....
*  xloc <0 outside plot, =0 left inside corner =number, choose x location
*label#=0 (nothing) 1(a) 2(b)  nvars=1-any, but >9 is grey
*     See color defs below to increase the number of colors
*     or to reorder them to preference.

*****   Define some coordinates *****
* this has mostly been tested on full page line plots
* the scaling has worked on smaller plots, but may
* need some intervention if the appearance is not
* adequate

'set lwid 20 5'

*'set rgb 25 206 112 34'

'q gxinfo'
say  result
xref=subwrd(result,14)
yref=subwrd(result,22)
x2=subwrd(result,16)
y2=subwrd(result,20)
xtot=subwrd(result,8)
ytot=subwrd(result,10)
scale=((x2-xref)*(x2-xref)+(yref-y2)*(yref-y2))/(xtot*xtot+ytot*ytot)
'q time'
t1=subwrd(result,3)
t2=subwrd(result,5)
if(t1 != t2)
'set t 1'
endif
'set z 1'
say scale
* this define and display does not work for t fixed and plev variable
'define a=sqrt('scale')'
'd a'
*say result
scale=subwrd(result,4)
*say xref'  'yref'  'scale
size=0.20*scale
*****

*****  Begin defining the labels and colors
ll=subwrd(args,1)
nvars=subwrd(args,2)
xloc=subwrd(args,3)

nv=1
while(nv<=nvars)
ag1=nv+3
label.nv=subwrd(args,ag1)

nv=nv+1
endwhile

******
* List of colors. Can be increased or reordered to preference, or tied
* to a palette of the users choice.
* nvmax is the number of defined colors, all calls above that will
* be grey
nvmax=11
c.1=31;c.2=49;c.3=33;c.4=36;c.5=45;c.6=42;c.7=44;c.8=43;c.9=32;c.11=1 ;c.10=1
* c.1=1;c.2=2;c.3=4;c.4=3;c.5=6;c.6=12;c.7=11;c.8=9;c.9=7

xloc1=xloc
if(xloc<0);xloc1=xref;endif

p1=xloc1+0.15
p3=xloc1+0.60
p5=xloc1+0.65
deltap=0.40*scale
'set strsiz 'size

'set string 1 l 9 0'

if(ll<0); yref=-ll;endif

p2=yref-deltap

nv=1

while(nv<=nvars)

col1=c.nv
if(nv>nvmax);col1=15;endif

'set line 'col1' 1 20'
if(nv=nvmax);'set line 'col1' 6 20' ; endif
'draw line 'p1' 'p2' 'p3' 'p2
'draw string 'p5' 'p2' 'label.nv

p2=p2-deltap

nv=nv+1
endwhile

**** Simply draw labels for multi panel plots
ya=yref+deltap

if(ll=1 | ll=-1)
'draw string 'x2' 'ya' (a)'
endif

if(ll=2 | ll=-2)
'draw string 'x2' 'ya' (b)'
endif

if(ll=3 | ll=-3)
'draw string 'x2' 'ya' (c)'
endif

if(ll=4 | ll=-4)
'draw string 'x2' 'ya' (d)'
endif


if(t1 != t2)
'set time 't1' 't2
endif

return

