function linear (args)
*run as slope_stats xvar yvar tstart tend lon1 lon2 lat1 lat2 (n) (pl11)
* n is used for plotting a second set of statistics and fit
* The 1:1 line assumes that the x and y ranges are identical, and if not, it uses 
*   x limits

xvar1=subwrd(args,1)
yvar1=subwrd(args,2)
t1=subwrd(args,3)
t2=subwrd(args,4)
lon1=subwrd(args,5)
lon2=subwrd(args,6)
lat1=subwrd(args,7)
lat2=subwrd(args,8)
nplt=subwrd(args,9)
pl11=subwrd(args,10)

if(pl11='');pl11=1;endif
if(nplt='');nplt=1;endif


'set time 't1' 't2
'set lon 'lon1' 'lon2
'set lat 'lat1' 'lat2

'define xvar=maskout('xvar1',abs('yvar1'))'
'define yvar=maskout('yvar1',abs('xvar1'))'

'set time 't1
'set lon 'lon1
'set lat 'lat1
dom='lon='lon1',lon='lon2',lat='lat1',lat='lat2
say dom
tdom='time='t1',time='t2

if(lon1!=lon2 | lat1!=lat2)
'd sum(asum(maskout(1,abs(xvar)),'dom'),'tdom')'
ncnt=sublin(result,2);ncnt=subwrd(ncnt,4)
'd sum(asum(xvar,'dom'),'tdom')'
xsum=sublin(result,2);xsum=subwrd(xsum,4)
'd sum(asum(yvar,'dom'),'tdom')'
ysum=sublin(result,2);ysum=subwrd(ysum,4)
xbar=xsum/ncnt
ybar=ysum/ncnt
'd sum(asum((xvar-'xbar')*(yvar-'ybar'),'dom'),'tdom')'
sumxy=sublin(result,2);sumxy=subwrd(sumxy,4)
'd sum(asum((xvar-'xbar')*(xvar-'xbar'),'dom'),'tdom')'
sumxx=sublin(result,2);sumxx=subwrd(sumxx,4)
else
'd sum(maskout(1,abs(xvar)),'tdom')'
ncnt=sublin(result,2);ncnt=subwrd(ncnt,4)
'd sum(xvar,'tdom')'
xsum=sublin(result,2);xsum=subwrd(xsum,4)
'd sum(yvar,'tdom')'
ysum=sublin(result,2);ysum=subwrd(ysum,4)
xbar=xsum/ncnt
ybar=ysum/ncnt
'd sum((xvar-'xbar')*(yvar-'ybar'),'tdom')'
sumxy=sublin(result,2);sumxy=subwrd(sumxy,4)
'd sum((xvar-'xbar')*(xvar-'xbar'),'tdom')'
sumxx=sublin(result,2);sumxx=subwrd(sumxx,4)
'd tcorr(xvar,yvar,'tdom')'
tcor=subwrd(result,14)
say result
endif

slope=sumxy/sumxx
int=ybar-slope*xbar

say ncnt' 'xbar' 'ybar' 'xsum' 'ysum
say 'Y = 'int' + 'slope'*X'



****Draw lines
b=slope
a=int

'q gxinfo'
say result

lim=sublin(result,3)
xlim1=subwrd(lim,4)
xlim2=subwrd(lim,6)
lim=sublin(result,4)
ylim1=subwrd(lim,4)
ylim2=subwrd(lim,6)

say result

col1=1
say nplt
if(nplt=2);col1=2;endif
***********************

'q xy2w 'xlim1' 'ylim1
say result
x1a=subwrd(result,3)
y1a=subwrd(result,6)
y1=a+b*x1a
if(y1<y1a)
x1=(y1a-a)/b
y1=y1a
x1a=y1a
else
x1=x1a
y1a=x1a
endif
'q w2xy 'x1' 'y1
xx1=subwrd(result,3)
yy1=subwrd(result,6)

'q xy2w 'xlim2' 'ylim2
x2a=subwrd(result,3)
y2a=subwrd(result,6)
y2=a+b*x2a
if(y2>y2a)
x2=(y2a-a)/b
y2=y2a
x2a=y2a
else
x2=x2a
y2a=x2a
endif

'q w2xy 'x2' 'y2
xx2=subwrd(result,3)
yy2=subwrd(result,6)

'set line 'col1' 1 6'
'draw line 'xx1' 'yy1' 'xx2' 'yy2

*Draw 1:1 line

'q w2xy 'x1a' 'x1a
xx1=subwrd(result,3)
yy1=subwrd(result,6)

'q w2xy 'x2a' 'x2a
xx2=subwrd(result,3)
yy2=subwrd(result,6)

if(pl11=1)
'set line 2 2 6'
'draw line 'xx1' 'yy1' 'xx2' 'yy2
endif


*****

fmt='%-8.3f'
slout=math_format(fmt,b)
aout=math_format(fmt,a)

say "q gxinfo"
'q gxinfo'
* 16 will go right outside
*xlo=subwrd(result,16)
* 14 will go left side inside the scatter
*say result
xlo=subwrd(result,14)
yhi=subwrd(result,22)

*say xlo
xlo=xlo+0.1
if(nplt=2);xlo=xlo+2.0;endif

dy=0.2

yhi=yhi-dy


'set string 'col1' tl 8'
'set strsiz 0.15'
yhi1=yhi
'draw string 'xlo' 'yhi1' Slope = 'slout
fmt='%5.2f'

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' Int  = 'aout

yhi1=yhi1-dy

ncnt=math_nint(ncnt)
'draw string 'xlo' 'yhi1' Count = 'ncnt

yhi1=yhi1-dy

if(lon1=lon2 & lat1=lat2)
fmt='%5.2f'
say tcor
tcorr=math_format(fmt,tcor)
'draw string 'xlo' 'yhi1' Corr(t)  = 'tcorr
endif

return(b)

*bias=xbar-ybar
*fmt='%-6.3f'
*bias=math_format(fmt,bias)
*'draw string 'xlo' 'yhi1' Mean Bias  = 'bias

*yhi1=yhi1-dy

*'draw string 'xlo' 'yhi1' std diff = 'stddiff

*yhi1=yhi1-dy

*'draw string 'xlo' 'yhi1' ycorr = 'rsout




