function linear (args)
*run as slope_stats xvar yvar (1)
*  Use 1 to solve a slope for y-intercept = 0
* The 1:1 line assumes that the x and y ranges are identical, and if not, it use
s
*   x limits

xvar1=subwrd(args,1)
yvar1=subwrd(args,2)
doab=subwrd(args,3)

'define xvar='xvar1
'define yvar='yvar1

'set gxout stat'

'd xvar-yvar'

tmp=sublin(result,11)
bias=subwrd(tmp,2)
tmp=sublin(result,13)
stddiff=subwrd(tmp,2)

say result

'd xvar'

*say result

tmp=sublin(result,11)
xbar=subwrd(tmp,2)
tmp=sublin(result,7)
ncnt=subwrd(tmp,8)

'd yvar'
tmp=sublin(result,11)
ybar=subwrd(tmp,2)

if(doab=1)
'd xvar*xvar'
tmp=sublin(result,11)
xsqbar=subwrd(tmp,2)


'd yvar*xvar'
tmp=sublin(result,11)
xybar=subwrd(tmp,2)


slope=xybar/xsqbar

*say slope

'define ypred=xvar*'slope

'set gxout line'
*Compute correlation between y,ypred
'd amean(ypred,global)'
ypbar=subwrd(result,4)
*say result
*say ypbar

'define y1=yvar-'ybar
'define yp1=ypred-'ypbar

'd sqrt(amean(y1*y1,global))'
sigy=subwrd(result,4)
*say result

'd sqrt(amean(yp1*yp1,global))'
sigyp=subwrd(result,4)
*say result

'd amean(y1*yp1,global)'
covyyp=subwrd(result,4)
*say result

corr=covyyp/(sigy*sigyp)

*say slope' 'corr' xb='xbar' yb='ybar

endif

**** Linear fit with intercept

if(doab="")
'set gxout line'

'd amean(xvar,global)'

sx=subwrd(result,4)
*
'd amean(yvar,global)'
sy=subwrd(result,4)
*
'd amean(xvar*xvar,global)'
sxx=subwrd(result,4)
*
'd amean(xvar*yvar,global)'
sxy=subwrd(result,4)
*
say sxx' 'sx
dels=sxx-sx*sx

a=(sxx*sy-sx*sxy)/dels

b=(sxy-sx*sy)/dels
slope=b

say a' + 'b'*X'

'define ypred=xvar*'b'+'a
say result

*Compute correlation between y,ypred
'd amean(ypred,global)'
ypbar=subwrd(result,4)

*say result
*say ypbar
*say ybar

'define y1=yvar-'ybar
*say result
'define yp1=ypred-'ypbar
*say result

'd sqrt(amean(y1*y1,global))'
sigy=subwrd(result,4)
*say result

'd sqrt(amean(yp1*yp1,global))'
sigyp=subwrd(result,4)
*say result

'd amean(y1*yp1,global)'
covyyp=subwrd(result,4)
*say result

corr=covyyp/(sigy*sigyp)

endif

****Draw lines

'q gxinfo'

lim=sublin(result,3)
xlim1=subwrd(lim,4)
xlim2=subwrd(lim,6)
lim=sublin(result,4)
ylim1=subwrd(lim,4)
ylim2=subwrd(lim,6)

say result

if(doab=1)

'q xy2w 'xlim1' 'ylim1
x1=subwrd(result,3)
y1=slope*x1
'q w2xy 'x1' 'y1
xx1=subwrd(result,3)
yy1=subwrd(result,6)

'q xy2w 'xlim2' 'ylim2
x2=subwrd(result,3)
y2=slope*x2
'q w2xy 'x2' 'y2
xx2=subwrd(result,3)
yy2=subwrd(result,6)

'set line 3 1 6'
'draw line 'xx1' 'yy1' 'xx2' 'yy2
endif

if(doab="")
'q xy2w 'xlim1' 'ylim1
x1=subwrd(result,3)
y1=a+b*x1
'q w2xy 'x1' 'y1
xx1=subwrd(result,3)
yy1=subwrd(result,6)

'q xy2w 'xlim2' 'ylim2
x2=subwrd(result,3)
y2=a+b*x2
'q w2xy 'x2' 'y2
xx2=subwrd(result,3)
yy2=subwrd(result,6)

'set line 4 1 6'
'draw line 'xx1' 'yy1' 'xx2' 'yy2
endif

'q w2xy 'x1' 'x1
xx1=subwrd(result,3)
yy1=subwrd(result,6)

'q w2xy 'x2' 'x2
xx2=subwrd(result,3)
yy2=subwrd(result,6)

'set line 2 2 6'
'draw line 'xx1' 'yy1' 'xx2' 'yy2

*****

slout=substr(slope,1,6)
rsout=substr(corr,1,6)
if(doab="")
aout=substr(a,1,6)
slout=substr(b,1,6)
endif


'q gxinfo'
say result


xlo=subwrd(result,14)
yhi=subwrd(result,22)+0.13

xlo=xlo+0.05
dy=0.16

yhi=yhi-dy

'set string 4 tl 6'
'set strsiz 0.11'

if(doab=1)

'draw string 'xlo' 'yhi' ycorr = 'rsout

yhi1=yhi-dy

'draw string 'xlo' 'yhi1' slope = 'slout

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' count = 'ncnt

endif

if(doab="")

yhi1=yhi
'draw string 'xlo' 'yhi1' corr = 'rsout

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' slope = 'slout

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' yint  = 'aout

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' count = 'ncnt
endif

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' bias  = 'bias

yhi1=yhi1-dy

'draw string 'xlo' 'yhi1' std diff = 'stddiff


